diff --git a/sound/pci/au88x0/au88x0_xtalk.c b/sound/pci/au88x0/au88x0_xtalk.c
index 084fcbf..143646c 100644
--- a/sound/pci/au88x0/au88x0_xtalk.c
+++ b/sound/pci/au88x0/au88x0_xtalk.c
@@ -17,39 +17,20 @@
 static short const sXtalkWideKLeftEq = 0x269C;
 static short const sXtalkWideKRightEq = 0x269C;
 static short const sXtalkWideKLeftXt = 0xF25E;
-static short const sXtalkWideKRightXt = 0xF25E;
 static short const sXtalkWideShiftLeftEq = 1;
 static short const sXtalkWideShiftRightEq = 1;
 static short const sXtalkWideShiftLeftXt = 0;
-static short const sXtalkWideShiftRightXt = 0;
 static unsigned short const wXtalkWideLeftDelay = 0xd;
 static unsigned short const wXtalkWideRightDelay = 0xd;
 static short const sXtalkNarrowKLeftEq = 0x468D;
 static short const sXtalkNarrowKRightEq = 0x468D;
 static short const sXtalkNarrowKLeftXt = 0xF82E;
-static short const sXtalkNarrowKRightXt = 0xF82E;
 static short const sXtalkNarrowShiftLeftEq = 0x3;
 static short const sXtalkNarrowShiftRightEq = 0x3;
 static short const sXtalkNarrowShiftLeftXt = 0;
-static short const sXtalkNarrowShiftRightXt = 0;
 static unsigned short const wXtalkNarrowLeftDelay = 0x7;
 static unsigned short const wXtalkNarrowRightDelay = 0x7;
 
-static xtalk_gains_t const asXtalkGainsDefault = {
-	0x4000, 0x4000, 0x4000, 0x4000, 0x4000,
-	0x4000, 0x4000, 0x4000, 0x4000,	0x4000
-};
-
-static xtalk_gains_t const asXtalkGainsTest = {
-	0x7fff, 0x8000, 0x0000, 0x0000, 0x0001,
-	0xffff, 0x4000, 0xc000, 0x0002, 0xfffe
-};
-
-static xtalk_gains_t const asXtalkGains1Chan = {
-	0x7FFF, 0, 0, 0, 0,
-	0x7FFF, 0, 0, 0, 0,
-};
-
 // Input gain for 4 A3D slices. One possible input pair is left zero.
 static xtalk_gains_t const asXtalkGainsAllChan = {
 	0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0,
@@ -64,20 +45,11 @@ static xtalk_dline_t const alXtalkDlineZeros = {
 	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 };
-static xtalk_dline_t const alXtalkDlineTest = {
-	0x0000fc18, 0xfff03e8, 0x000186a0, 0xfffe7960, 1, 0xffffffff, 0, 0,
-	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
-	0, 0, 0, 0, 0, 0, 0, 0
-};
 
 static xtalk_instate_t const asXtalkInStateZeros = {
 	0, 0, 0, 0
 };
 
-static xtalk_instate_t const asXtalkInStateTest = {
-	0x0080, 0xff80, 0x0001, 0xffff
-};
-
 static xtalk_state_t const asXtalkOutStateZeros = {
 	{0, 0, 0, 0},
 	{0, 0, 0, 0},
@@ -89,11 +61,9 @@ static xtalk_state_t const asXtalkOutStateZeros = {
 static short const sDiamondKLeftEq = 0x401d;
 static short const sDiamondKRightEq = 0x401d;
 static short const sDiamondKLeftXt = 0xF90E;
-static short const sDiamondKRightXt = 0xF90E;
 static short const sDiamondShiftLeftEq = 1;
 static short const sDiamondShiftRightEq = 1;
 static short const sDiamondShiftLeftXt = 0;
-static short const sDiamondShiftRightXt = 0;
 static unsigned short const wDiamondLeftDelay = 0xb;
 static unsigned short const wDiamondRightDelay = 0xb;
 
@@ -118,13 +88,6 @@ static xtalk_coefs_t const asXtalkWideCoefsLeftXt = {
 	{0x77dc, 0xc79e, 0xffb8, 0x000a, 0},
 	{0, 0, 0, 0, 0}
 };
-static xtalk_coefs_t const asXtalkWideCoefsRightXt = {
-	{0x55c6, 0xc97b, 0x005b, 0x0047, 0},
-	{0x6a60, 0xca20, 0xffc6, 0x0040, 0},
-	{0x6411, 0xd711, 0xfca1, 0x0190, 0},
-	{0x77dc, 0xc79e, 0xffb8, 0x000a, 0},
-	{0, 0, 0, 0, 0}
-};
 static xtalk_coefs_t const asXtalkNarrowCoefsLeftEq = {
 	{0x50B5, 0xD07C, 0x026D, 0xFD21, 0},
 	{0x460F, 0xE44F, 0xF75E, 0xEFA6, 0},
@@ -149,14 +112,6 @@ static xtalk_coefs_t const asXtalkNarrowCoefsLeftXt = {
 	{0, 0, 0, 0, 0}
 };
 
-static xtalk_coefs_t const asXtalkNarrowCoefsRightXt = {
-	{0x3CB2, 0xDF49, 0xF6EA, 0x095B, 0},
-	{0x6777, 0xC915, 0xFEAF, 0x00B1, 0},
-	{0x7762, 0xC7D9, 0x025B, 0xFDA6, 0},
-	{0x6B7A, 0xD2AA, 0xF2FB, 0x0B64, 0},
-	{0, 0, 0, 0, 0}
-};
-
 static xtalk_coefs_t const asXtalkCoefsZeros = {
 	{0, 0, 0, 0, 0},
 	{0, 0, 0, 0, 0},
@@ -172,37 +127,6 @@ static xtalk_coefs_t const asXtalkCoefsPipe = {
 	{0, 0, 0x0FA0, 0, 0},
 	{0, 0, 0x1180, 0, 0},
 };
-static xtalk_coefs_t const asXtalkCoefsNegPipe = {
-	{0, 0, 0xF380, 0, 0},
-	{0, 0, 0xF380, 0, 0},
-	{0, 0, 0xF380, 0, 0},
-	{0, 0, 0xF380, 0, 0},
-	{0, 0, 0xF200, 0, 0}
-};
-
-static xtalk_coefs_t const asXtalkCoefsNumTest = {
-	{0, 0, 0xF380, 0x8000, 0x6D60},
-	{0, 0, 0, 0, 0},
-	{0, 0, 0, 0, 0},
-	{0, 0, 0, 0, 0},
-	{0, 0, 0, 0, 0}
-};
-
-static xtalk_coefs_t const asXtalkCoefsDenTest = {
-	{0xC000, 0x2000, 0x4000, 0, 0},
-	{0, 0, 0, 0, 0},
-	{0, 0, 0, 0, 0},
-	{0, 0, 0, 0, 0},
-	{0, 0, 0, 0, 0}
-};
-
-static xtalk_state_t const asXtalkOutStateTest = {
-	{0x7FFF, 0x0004, 0xFFFC, 0},
-	{0xFE00, 0x0008, 0xFFF8, 0x4000},
-	{0x0200, 0x0010, 0xFFF0, 0xC000},
-	{0x8000, 0x0020, 0xFFE0, 0},
-	{0, 0, 0, 0}
-};
 
 static xtalk_coefs_t const asDiamondCoefsLeftEq = {
 	{0x0F1E, 0x2D05, 0xF8E3, 0x07C8, 0},
@@ -228,15 +152,6 @@ static xtalk_coefs_t const asDiamondCoefsLeftXt = {
 	{0, 0, 0, 0, 0}
 };
 
-static xtalk_coefs_t const asDiamondCoefsRightXt = {
-	{0x3B50, 0xFE08, 0xF959, 0x0060, 0},
-	{0x9FCB, 0xD8F1, 0x00A2, 0x003A, 0},
-	{0, 0, 0, 0, 0},
-	{0, 0, 0, 0, 0},
-	{0, 0, 0, 0, 0}
-};
-
- /**/
 /* XTalk EQ and XT */
 static void
 vortex_XtalkHw_SetLeftEQ(vortex_t * vortex, short arg_0, short arg_4,